﻿var util = require('util');
var ViewResult = require("./ViewResult");
var RedirectResult = require("./RedirectResult");
var controllerConstructor = function (options) {
    this.User = {};
    this.context = {};
    this.controllerContext = {};
    var init = function (opt) {

    };
   

    init(options);
}
controllerConstructor.prototype.view = function (name, data) {
    //TODO:抽象VituralPathProvider功能，剥离路径查找逻辑
    var viewPath = "";
    if (arguments.length == 1 && typeof (name) != "string") {
        //使用默认的视图
        viewPath = util.format("%s/%s", this.controllerContext.controller, this.controllerContext.action)
        data = name;
    } else if(arguments.length>1){
        //包含/,说明是全路径
        if (name.indexOf("/") > -1) {
            viewPath = name;
        } else {
            viewPath = util.format("%s/" + name, this.controllerContext.controller);
        }
    } else {
        //使用默认的视图
        viewPath = util.format("%s/%s", this.controllerContext.controller, this.controllerContext.action)
        data = null;
    }
    // if (name == undefined || name=="") name = this.controllerContext.action;
    return new ViewResult({ view: viewPath, model: data ,viewbag:this.ViewBag}, this.context);
};
controllerConstructor.prototype.onAuthorized = function () {

};

controllerConstructor.prototype.ViewBag = function () {

};


controllerConstructor.prototype.redirectToAction = function (action, controller) {
    console.log("baseController:redirectToAction:Redirection:");
    console.log(RedirectResult);
    return new RedirectResult({ url: util.format("/%s/$s", controller, action) }, this.context);
}
module.exports = controllerConstructor;
